////////////////////////////////////////////////////////////////////////////////////////////////////
/// @file	ISP.h
/// @author	Simon Qian(webmaster@SimonQian.com)
/// @date	Last Update on 2008-04-07
/// @brief	headerfile for ISP.c
/// @par	license
/// 		AVRminiProg is distributed under the terms and conditions of GPLv2, see License.txt
////////////////////////////////////////////////////////////////////////////////////////////////////

// ISP Interfaces:
// MOSI		<-->	O	defined in spi module
// MISO		<-->	I	defined in spi module
// SCK		<-->	O	defined in spi module
// RST		<-->	O

/// ISP Disable Reset
#define ISP_RST_Off()									if(Reset_Polarity)ISP_SetRST();else ISP_ClrRST()
/// ISP Enable Reset
#define ISP_RST_On()									if(Reset_Polarity)ISP_ClrRST();else ISP_SetRST()


void ISP_Init(void);
void ISP_Fini(void);
void ISP_Comm(uint8*,uint8*);

#define ISP_Error					1
#define ISP_Success					0

#if ISP_AutoSpeed_En
extern uint8 ISP_Speed[10];
#define ISP_AutoSpeed_Max			7
#define ISP_AutoSpeed_CheckTimes_H	1
#define ISP_AutoSpeed_CheckTimes_L	1
#endif

uint8 ISP_RDY_Wait(void);
