////////////////////////////////////////////////////////////////////////////////////////////////////
/// @file	gpio.h
/// @author	Simon Qian(webmaster@SimonQian.com)
/// @date	Last Update on 2008-04-07
/// @brief	headerfile for GPIO Functions
/// @par	license
/// 		AVRminiProg is distributed under the terms and conditions of GPLv2, see License.txt
////////////////////////////////////////////////////////////////////////////////////////////////////

#include "general.h"

#define P(n)					_BV(n)

#define PortA_SetOutput(PINS)	SetMsk(DDRA,(PINS))//(DDRB |= (PINS))
#define PortA_SetInput(PINS)	ClearMsk(DDRA,(PINS))//(DDRB &= ~(PINS))
#define PortA_SetDir(PINS)		(DDRA = (PINS))
#define PortA_SetPin(PINS)		SetMsk(PORTA,(PINS))//(PORTB |= (PINS))
#define PortA_ClrPin(PINS)		ClearMsk(PORTA,(PINS))//(PORTB &= ~(PINS))
#define PortA_Out(DATA)			(PORTA = (DATA))
#define PortA_GetPin(PINS)		RegGetRgn(PINA,(PINS))//(PINB & (PINS))

#define PortB_SetOutput(PINS)	SetMsk(DDRB,(PINS))//(DDRB |= (PINS))
#define PortB_SetInput(PINS)	ClearMsk(DDRB,(PINS))//(DDRB &= ~(PINS))
#define PortB_SetDir(PINS)		(DDRB = (PINS))
#define PortB_SetPin(PINS)		SetMsk(PORTB,(PINS))//(PORTB |= (PINS))
#define PortB_ClrPin(PINS)		ClearMsk(PORTB,(PINS))//(PORTB &= ~(PINS))
#define PortB_Out(DATA)			(PORTB = (DATA))
#define PortB_GetPin(PINS)		RegGetRgn(PINB,(PINS))//(PINB & (PINS))

#define PortC_SetOutput(PINS)	SetMsk(DDRC,(PINS))//(DDRC |= (PINS))
#define PortC_SetInput(PINS)	ClearMsk(DDRC,(PINS))//(DDRC &= ~(PINS))
#define PortC_SetDir(PINS)		(DDRC = (PINS))
#define PortC_SetPin(PINS)		SetMsk(PORTC,(PINS))//(PORTC |= (PINS))
#define PortC_ClrPin(PINS)		ClearMsk(PORTC,(PINS))//(PORTC &= ~(PINS))
#define PortC_Out(DATA)			(PORTC = (DATA))
#define PortC_GetPin(PINS)		RegGetRgn(PINC,(PINS))//(PINC & (PINS))

#define PortD_SetOutput(PINS)	SetMsk(DDRD,(PINS))//(DDRD |= (PINS))
#define PortD_SetInput(PINS)	ClearMsk(DDRD,(PINS))//(DDRD &= ~(PINS))
#define PortD_SetDir(PINS)		(DDRD = (PINS))
#define PortD_SetPin(PINS)		SetMsk(PORTD,(PINS))//(PORTD |= (PINS))
#define PortD_ClrPin(PINS)		ClearMsk(PORTD,(PINS))//(PORTD &= ~(PINS))
#define PortD_Out(DATA)			(PORTD = (DATA))
#define PortD_GetPin(PINS)		RegGetRgn(PIND,(PINS))//(PIND & (PINS))
