////////////////////////////////////////////////////////////////////////////////////////////////////
/// @file	type.h
/// @author	Simon Qian(webmaster@SimonQian.com)
/// @date	Last Update on 2008-04-07
/// @brief	type define
/// @par	license
/// 		AVRminiProg is distributed under the terms and conditions of GPLv2, see License.txt
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef __TYPE_H_INCLUDED__

#define __TYPE_H_INCLUDED__
/// 8-bit unsigned integer
typedef unsigned char uint8;
/// 8-bit signed integer
typedef signed char int8;
/// 16-bit unsigned integer
typedef unsigned int uint16;
/// 16-bit signed integer
typedef signed int int16;
/// 32-bit unsigned integer
typedef unsigned long long uint32;
/// 32-bit signed integer
typedef signed long long int32;

typedef union{
	uint16	word;
	uint8	bytes[2];
}t_u16;

typedef union{
	uint32	dword;
	uint16	word[2];
	uint8	bytes[4];
}t_u32;

#endif
